/* vim: set sw=4 sts=4 et foldmethod=syntax : */

#include <gtest/gtest.h>
#include "segway_RMP400.h" 
#include "exceptions.h"

int g_argc;
char** g_argv;

TEST(Driver, constructor_destructor)
{
     ASSERT_NO_THROW ({
             CSegwayRMP400 * segway = new CSegwayRMP400();
             delete segway;
     });
}

TEST(Driver, startstop)
{
    CSegwayRMP400 * segway = new CSegwayRMP400();
    ASSERT_NO_THROW(segway->start());
    ASSERT_NO_THROW(segway->stop());
    delete segway;
}

TEST(Driver, startstoptwice)
{
    CSegwayRMP400 * segway = new CSegwayRMP400();
    ASSERT_NO_THROW(segway->start());
    ASSERT_NO_THROW(segway->stop());
    ASSERT_NO_THROW(segway->start());
    ASSERT_NO_THROW(segway->stop());
    delete segway;
}

TEST(Driver, connected)
{
    CSegwayRMP400 * segway = new CSegwayRMP400();
    ASSERT_FALSE(segway->is_connected());
    segway->start();
    ASSERT_TRUE(segway->is_connected());
    segway->stop();
    ASSERT_FALSE(segway->is_connected());
    delete segway;
}

TEST(Driver, reset_integrators)
{
    CSegwayRMP400 * segway = new CSegwayRMP400();
    segway->start();
    ASSERT_NO_THROW(segway->reset_integrators());
    segway->stop();
    delete segway;
}

int main(int argc, char **argv)
{
     testing::InitGoogleTest(&argc, argv);
     g_argc = argc;
     g_argv = argv;
     return RUN_ALL_TESTS();
}
